import sys
from collections import deque, defaultdict


def bfs(start, maximH, graph, visited):
    queue = deque([(start, 0)])
    visited.add(start)

    while queue:
        node, distance = queue.popleft()
        if distance < maximH:
            for n in graph[node]:
                if n not in visited:
                    visited.add(n)
                    queue.append((n, distance + 1))


def solve(n, m, k, graph):
    s = set()
    for i in range(m + 1, m + k + 1):
        p, h = map(int, sys.stdin.readline().split())
        bfs(p, h, graph, s)
    answer = sorted(list(s))
    return str(len(answer)), ' '.join(list(map(str, answer))) if answer else ''


def main():
    n, m, k = map(int, sys.stdin.readline().split())
    graph = defaultdict(list)
    for _ in range(m):
        a, b = map(int, sys.stdin.readline().split())
        graph[a].append(b)
        graph[b].append(a)
    ans1, ans2 = solve(n, m, k, graph)
    sys.stdout.write(ans1 + '\n' + ans2)


if __name__ == "__main__":
    main()
