from collections import deque, defaultdict


def bfs(start, maximH, graph, visited):
    queue = deque([(start, 0)])
    visited.add(start)

    while queue:
        node, distance = queue.popleft()
        if distance < maximH:
            for n in graph[node]:
                if n not in visited:
                    visited.add(n)
                    queue.append((n, distance + 1))


def solve(n, m, k, graph):
    s = set()
    for i in range(k):
        p, h = map(int, input().split())
        bfs(p, h, graph, s)
    ans = sorted(list(s))
    print(len(ans))
    print(*ans)


def main():
    n, m, k = map(int, input().split())
    graph = defaultdict(list)
    for _ in range(m):
        a, b = map(int, input().split())
        graph[a].append(b)
        graph[b].append(a)
    solve(n, m, k, graph)


if __name__ == "__main__":
    main()
