from collections import deque, defaultdict


def bfs(start, maximH, graph, visited):
    queue = deque([(start, 0)])
    visited[start] = True
    all_d = 0
    while queue:
        node, distance = queue.popleft()
        all_d += distance
        if all_d < maximH:

            for n in graph[node]:
                if not visited[n]:
                    visited[n] = True
                    queue.append((n,1))


def solve(n, m, k, graph):
    vis = [False] * n
    for i in range(k):
        p, h = map(int, input().split())
        p -= 1
        bfs(p, h, graph, vis)
    answer = []
    for i in range(n):
        if vis[i]:
            answer.append(i + 1)

    print(len(answer))
    print(*answer)


def main():
    n, m, k = map(int, input().split())
    graph = defaultdict(set)
    for _ in range(m):
        a, b = map(int, input().split())
        a -= 1
        b -= 1
        graph[a].add(b)
        graph[b].add(a)
    solve(n, m, k, graph)


if __name__ == "__main__":
    main()
